#include "wiced.h"
#include "simpleCli.h"
#include "UartTest.h"

#define UART2_TEST_STR          "Uart2 loop"


wiced_uart_config_t uart2_config =
{
    .baud_rate    = 115200,
    .data_width   = DATA_WIDTH_8BIT,
    .parity       = NO_PARITY,
    .stop_bits    = STOP_BITS_1,
    .flow_control = FLOW_CONTROL_DISABLED,
};

wiced_ring_buffer_t rx2_buffer;
uint8_t             rx2_data[64];
wiced_bool_t bUart2_init=WICED_FALSE;

static int UART2_TRx(int index, char *string, int len, void *printer) {
	char rx_str[64]={0};
	uint32_t expected_data_size = (sizeof( UART2_TEST_STR )-1);

	if(string != NULL && len != 0) return 0;
	
    /* Send a test string to the terminal */
    wiced_uart_transmit_bytes( WICED_UART_3, UART2_TEST_STR, sizeof( UART2_TEST_STR ) - 1 );
    wiced_rtos_delay_microseconds(500);

    if(wiced_uart_receive_bytes( WICED_UART_3, &rx_str, &expected_data_size, 500 )== WICED_SUCCESS){
    	rx_str[expected_data_size]=0x0;
    	console_printf("%s\r\n", rx_str);
    }
    else{
    	console_printf("N.G.\r\n");
    }

    return true;
}

static int UART2_Rx(int index, char *string, int len, void *printer) {
	if(string != NULL && len != 0) return 0;
	
	//do{
	    
    //} while(GetChar_wait()!=0x0D)

	return true;
}

int UartTest_Menu(int index, char *string, int len, void *printer) {
	if(string != NULL && len != 0) return 0;



	simple_cmds cmds[] = {
				{ "UART-2 Test" /*title*/,  				0,NULL },
				{ "TRx",							        0,UART2_TRx },
				{ NULL,										0,NULL }
	};

	if(bUart2_init==WICED_FALSE){
		bUart2_init=WICED_TRUE;
		/* Initialise ring buffer */
		ring_buffer_init(&rx2_buffer, rx2_data, 64 );

		/* Initialise UART. A ring buffer is used to hold received characters */
		wiced_uart_init( WICED_UART_3, &uart2_config, &rx2_buffer );
	}
	return simple_cli_list(cmds);
}

int Uart2_Auto_Test(void)
{
	wiced_result_t result;
	char rx_str[64]={0};
	uint32_t expected_data_size = (sizeof( UART2_TEST_STR )-1);

	if(bUart2_init==WICED_FALSE){
		bUart2_init=WICED_TRUE;
		/* Initialise ring buffer */
		ring_buffer_init(&rx2_buffer, rx2_data, 64 );

		/* Initialise UART. A ring buffer is used to hold received characters */
		wiced_uart_init( WICED_UART_3, &uart2_config, &rx2_buffer );
	}
    /* Send a test string to the terminal */
	result=wiced_uart_transmit_bytes( WICED_UART_3, UART2_TEST_STR, sizeof( UART2_TEST_STR ) - 1 );
    if(result != WICED_SUCCESS){
    	console_printf("Uart2_err1 ===> ");
    	return result;
    }
    wiced_rtos_delay_microseconds(100);
    result=wiced_uart_receive_bytes( WICED_UART_3, &rx_str, &expected_data_size, 500 );
    if(result != WICED_SUCCESS){
    	console_printf("Uart2_err2 ===> ");
    	return result;
    }
    result=strcmp(rx_str, (char *)UART2_TEST_STR);
    if(result!=0){
    	console_printf("Rx str=%s ===>", rx_str);
    	return -1;
    }

    return WICED_SUCCESS;
}
