﻿#include <stdbool.h>
#include "wiced.h"
#include "Susi4.h"
#include "susi_adc.h"

//static float g_Ch0_Voltage = 0.0;
//static float g_Ch4_Voltage = 0.0;

#define NO_OF_SAMPLES 		128

SusiStatus_t SUSI_API SusiADCRead(
	SusiId_t Id,		/* IN	ADC Bus Id */
	float *pValue	    /* OUT	ADC value (mV)*/
    ) {

	wiced_adc_t adc;
	uint16_t sample_value;

	// Convert pin number to channel number
	switch(Id)
	{
		case 0:
			adc=WICED_ADC_0;
			break;
		case 1:
			adc=WICED_ADC_1;
			break;
		case 2:
			adc=WICED_ADC_2;
			break;
		case 3:
			adc=WICED_ADC_3;
			break;
		default:
			return SUSI_STATUS_INVALID_PARAMETER;
	}
	wiced_adc_init( adc, NO_OF_SAMPLES );
    wiced_rtos_delay_microseconds(300);
    wiced_adc_take_sample(adc, &sample_value);


	*pValue = (float)(sample_value * 3300)/(float)4095;

	return SUSI_STATUS_SUCCESS;
}
